################################################################################
### import of daily weather data
pluiex<-read.table("pluiex.txt",header=T,na.strings="NA",dec=",")
tempx<-read.table("tempx.txt",header=T,na.strings="NA",dec=",")
hrx<-read.table("hrx.txt",header=T,na.strings="NA",dec=",")
ndvix<-read.table("ndvix.txt",header=T,na.strings="NA",dec=",")

pluiex$date<-strptime(pluiex$date, "%d/%m/%Y")
tempx$date<-strptime(tempx$date, "%d/%m/%Y")
hrx$date<-strptime(hrx$date, "%d/%m/%Y")
ndvix$date_ndvi<-strptime(ndvix$date_ndvi, "%d/%m/%Y")



################################################################################

library(fields)

################################################################################

abond<-bol.ent

################################################################################
####### TIME LAGS HERE 

## 2 times lags : nk=51 days et nk=31 days
## To obtain times lags of less than 30 days, set nk = 31
nk=51; nj=nk

#################################################################################
### list containing all species
### all species dataframe must have the same dimensions

Ylist<-as.data.frame(cbind(bol.ent$BME,ender.ent$BME,grah.ent$BME,imi.ent$BME,kib.ent$BME))
names(Ylist) <- c("bolitinos","enderleini","grahamii","imicola","kibatiensis")
dim(Ylist)

################################################################################
##### CCM 
Xrr<-pluiex$pluie[match(paste(abond$site,abond$date_pos), paste(pluiex$site,pluiex$date))]
     for(j in 2:nj){
           Xrr <- cbind(Xrr,pluiex$pluie[match(paste(abond$site,abond$date_pos), paste(pluiex$site,pluiex$date))-j+1])}         
           
Xlogrr<-log10(pluiex$pluie+1)[match(paste(abond$site,abond$date_pos), paste(pluiex$site,pluiex$date))]
     for(j in 2:nj){       
            Xlogrr<-cbind(Xlogrr,log10(pluiex$pluie+1)[match(paste(abond$site,abond$date_pos), paste(pluiex$site,pluiex$date))-j+1])}          

##### CCM temperature moyenne et log10 temperature moyenne
Xtmoy<-tempx$t_moy[match(paste(abond$site,abond$date_pos), paste(tempx$site,tempx$date))]
     for(j in 2:nj){      
           Xtmoy<- cbind(Xtmoy,tempx$t_moy[match(paste(abond$site,abond$date_pos), paste(tempx$site,tempx$date))-j+1])}
           
Xlogtmoy<-log10(tempx$t_moy+1)[match(paste(abond$site,abond$date_pos), paste(tempx$site,tempx$date))]
     for(j in 2:nj){      
           Xlogtmoy<- cbind(Xlogtmoy,log10(tempx$t_moy+1)[match(paste(abond$site,abond$date_pos), paste(tempx$site,tempx$date))-j+1])}   

##### CCM temperature min et log10 temperature min           
XtminP<-tempx$t_min[match(paste(abond$site,abond$date_pos), paste(tempx$site,tempx$date))]
     for(j in 2:nj){      
           XtminP<- cbind(XtminP,tempx$t_min[match(paste(abond$site,abond$date_pos), paste(tempx$site,tempx$date))-j+1])}
           
XlogtminP<-log10(ifelse(tempx$t_min < 0,0,tempx$t_min)+1)[match(paste(abond$site,abond$date_pos), paste(tempx$site,tempx$date))]
     for(j in 2:nj){      
           XlogtminP<- cbind(XlogtminP,log10(ifelse(tempx$t_min < 0,0,tempx$t_min)+1)[match(paste(abond$site,abond$date_pos), paste(tempx$site,tempx$date))-j+1])}           

##### CCM temperature max et log10 temperature max                   
XtmaxP<-tempx$t_max[match(paste(abond$site,abond$date_pos), paste(tempx$site,tempx$date))]
     for(j in 2:nj){      
           XtmaxP<- cbind(XtmaxP,tempx$t_max[match(paste(abond$site,abond$date_pos), paste(tempx$site,tempx$date))-j+1])}
           
XlogtmaxP<-log10(tempx$t_max +1)[match(paste(abond$site,abond$date_pos), paste(tempx$site,tempx$date))]
     for(j in 2:nj){      
           XlogtmaxP<- cbind(XlogtmaxP,log10(tempx$t_max +1)[match(paste(abond$site,abond$date_pos), paste(tempx$site,tempx$date))-j+1])}                

##### CCM humidite et log10 humidite        
Xhr<-hrx$hr[match(paste(abond$site,abond$date_pos), paste(hrx$site,hrx$date))]
     for(j in 2:nj){      
           Xhr<- cbind(Xhr,hrx$hr[match(paste(abond$site,abond$date_pos), paste(hrx$site,hrx$date))-j+1])}
           
Xloghr<-log10(hrx$hr+1)[match(paste(abond$site,abond$date_pos), paste(hrx$site,hrx$date))]
     for(j in 2:nj){      
           Xloghr<- cbind(Xloghr,log10(hrx$hr+1)[match(paste(abond$site,abond$date_pos), paste(hrx$site,hrx$date))-j+1])}           

##### CCM ndvi et log10 ndvi
Xndvi_est<-ndvix$ndvi_est[match(paste(abond$site,abond$date_pos), paste(ndvix$site,ndvix$date_ndvi))]
     for(j in 2:nj){      
           Xndvi_est<- cbind(Xndvi_est,ndvix$ndvi_est[match(paste(abond$site,abond$date_pos), paste(ndvix$site,ndvix$date_ndvi))-j+1])}
           
Xlogndvi_est<-log10(ndvix$ndvi_est+1)[match(paste(abond$site,abond$date_pos), paste(ndvix$site,ndvix$date_ndvi))]
     for(j in 2:nj){      
           Xlogndvi_est<- cbind(Xlogndvi_est,log10(ndvix$ndvi_est+1)[match(paste(abond$site,abond$date_pos), paste(ndvix$site,ndvix$date_ndvi))-j+1])}           

Xlist=c("Xrr","Xlogrr","Xtmoy","Xlogtmoy","XtminP","XlogtminP","XtmaxP","XlogtmaxP","Xhr","Xloghr","Xndvi_est","Xlogndvi_est")

dim(Xtmoy)

################################################################################

library(polycor)

################################################################################

for(i in 1:ncol(Ylist))  # all species
{
  Y <- Ylist[,i]
  Yname <- names(Ylist)[i]
  for(j in 1:length(Xlist)) # all variables
   { Xname <- Xlist[j]

if(j ==1) matrix.X <- Xrr
if(j ==2) matrix.X <-Xlogrr
if(j ==3) matrix.X <-Xtmoy
if(j ==4) matrix.X <-Xlogtmoy
if(j ==5) matrix.X <-XtminP
if(j ==6) matrix.X <-XlogtminP
if(j ==7) matrix.X <-XtmaxP
if(j ==8) matrix.X <-XlogtmaxP
if(j ==9) matrix.X <-Xhr
if(j ==10) matrix.X <-Xloghr
if(j ==11) matrix.X <-Xndvi_est
if(j ==12) matrix.X <-Xlogndvi_est

matrix.cor<-matrix(NA,ncol=nj,nrow=nk)

for (j in 1:nj){  
	matrix.cor[j,j]<-polyserial(matrix.X[,j],factor(Y))  
}
                     
for(j in 2:nj){
  for (k in 1:(j-1))  
	{matrix.cor[j,k]<-polyserial(rowMeans(matrix.X[,j:k],na.rm = TRUE),factor(Y))}
}
 
image.name <- paste("polyS",Yname,"~",Xname,"50d.png",sep="")   ## change the name for each CCM series

png(image.name)   ## the CCMs will be created in the directory file

x<-c(0:nk-0.5);y<-c(0:nj-0.5)
image.plot(x,y,matrix.cor, main=paste(Yname,"~",Xname),xlab="time lag 1", ylab="time lag 2", las=1, nlevel=30, zlim=c(-1,1))  

max.value<- max(matrix.cor,na.rm=T); min.value<- min(matrix.cor,na.rm=T)
if (abs(max.value)>=abs(min.value)){value=max.value} else {value=min.value}
place<-as.vector(which(matrix.cor==value, arr.ind=T))-1; lag.1 <- place[1]; lag.2 <- place[2]

lines(c(lag.1-0.5,lag.1+0.5,lag.1+0.5,lag.1-0.5,lag.1-0.5), c(lag.2-0.5,lag.2-0.5,lag.2+0.5,lag.2+0.5,lag.2-0.5), lwd=2.0)

r.max=paste("r(",place[1],",",place[2],") = ",round(value,digits=3), sep="")
r.00=paste("r(0,0) = ",round(matrix.cor[1,1],digits=3), sep="")

mtext(substitute(r.max,list(r.max=r.max)), side<-3, line=1, adj=1)
mtext(substitute(r.00,list(r.00=r.00)), side<-3, line=1, adj=0)

dev.off()
}
}  # end loop







